using System;
using System.Windows.Forms;
using LCDModuleLibrary;

namespace LCDModuleLibraryDemo
{
    public partial class MainFrm : Form
    {
        LCDModule.Lines lines; //Number of lines in LCD Module.
        LCDModule lcdModule; //Current LCD Module.
        CharacterFont[] charactersFont = new CharacterFont[8]; //Font.
        CheckBox[,] pixelCheckBoxes = new CheckBox[5, 8]; //Pixels.
        public MainFrm()
        {
            InitializeComponent();
            //Change this to LCDModule.Lines.OneLine, if you have one-line LCD Module!
            lines = LCDModule.Lines.TwoLines;
            //Change this to LCDModule.Ports.LPT2, if your LCD Module connected to LPT2!
            lcdModule = new LCDModule("Unregistered", "User", LCDModule.Ports.LPT1, lines);
            if (lines == LCDModule.Lines.OneLine) lineTwoTextBox.Enabled = false;
            lcdModule.Open();
            for (int i = 0; i < 8; i++) charactersFont[i] = new CharacterFont();
            #region Pixel Check Boxes
            pixelCheckBoxes[0, 0] = checkBox1;
            pixelCheckBoxes[1, 0] = checkBox2;
            pixelCheckBoxes[2, 0] = checkBox3;
            pixelCheckBoxes[3, 0] = checkBox4;
            pixelCheckBoxes[4, 0] = checkBox5;
            pixelCheckBoxes[0, 1] = checkBox6;
            pixelCheckBoxes[1, 1] = checkBox7;
            pixelCheckBoxes[2, 1] = checkBox8;
            pixelCheckBoxes[3, 1] = checkBox9;
            pixelCheckBoxes[4, 1] = checkBox10;
            pixelCheckBoxes[0, 2] = checkBox11;
            pixelCheckBoxes[1, 2] = checkBox12;
            pixelCheckBoxes[2, 2] = checkBox13;
            pixelCheckBoxes[3, 2] = checkBox14;
            pixelCheckBoxes[4, 2] = checkBox15;
            pixelCheckBoxes[0, 3] = checkBox16;
            pixelCheckBoxes[1, 3] = checkBox17;
            pixelCheckBoxes[2, 3] = checkBox18;
            pixelCheckBoxes[3, 3] = checkBox19;
            pixelCheckBoxes[4, 3] = checkBox20;
            pixelCheckBoxes[0, 4] = checkBox21;
            pixelCheckBoxes[1, 4] = checkBox22;
            pixelCheckBoxes[2, 4] = checkBox23;
            pixelCheckBoxes[3, 4] = checkBox24;
            pixelCheckBoxes[4, 4] = checkBox25;
            pixelCheckBoxes[0, 5] = checkBox26;
            pixelCheckBoxes[1, 5] = checkBox27;
            pixelCheckBoxes[2, 5] = checkBox28;
            pixelCheckBoxes[3, 5] = checkBox29;
            pixelCheckBoxes[4, 5] = checkBox30;
            pixelCheckBoxes[0, 6] = checkBox31;
            pixelCheckBoxes[1, 6] = checkBox32;
            pixelCheckBoxes[2, 6] = checkBox33;
            pixelCheckBoxes[3, 6] = checkBox34;
            pixelCheckBoxes[4, 6] = checkBox35;
            pixelCheckBoxes[0, 7] = checkBox36;
            pixelCheckBoxes[1, 7] = checkBox37;
            pixelCheckBoxes[2, 7] = checkBox38;
            pixelCheckBoxes[3, 7] = checkBox39;
            pixelCheckBoxes[4, 7] = checkBox40;
            pixelCheckBoxes[0, 0].CheckedChanged += new EventHandler(pixelCheckBoxes00_CheckedChanged);
            pixelCheckBoxes[1, 0].CheckedChanged += new EventHandler(pixelCheckBoxes10_CheckedChanged);
            pixelCheckBoxes[2, 0].CheckedChanged += new EventHandler(pixelCheckBoxes20_CheckedChanged);
            pixelCheckBoxes[3, 0].CheckedChanged += new EventHandler(pixelCheckBoxes30_CheckedChanged);
            pixelCheckBoxes[4, 0].CheckedChanged += new EventHandler(pixelCheckBoxes40_CheckedChanged);
            pixelCheckBoxes[0, 1].CheckedChanged += new EventHandler(pixelCheckBoxes01_CheckedChanged);
            pixelCheckBoxes[1, 1].CheckedChanged += new EventHandler(pixelCheckBoxes11_CheckedChanged);
            pixelCheckBoxes[2, 1].CheckedChanged += new EventHandler(pixelCheckBoxes21_CheckedChanged);
            pixelCheckBoxes[3, 1].CheckedChanged += new EventHandler(pixelCheckBoxes31_CheckedChanged);
            pixelCheckBoxes[4, 1].CheckedChanged += new EventHandler(pixelCheckBoxes41_CheckedChanged);
            pixelCheckBoxes[0, 2].CheckedChanged += new EventHandler(pixelCheckBoxes02_CheckedChanged);
            pixelCheckBoxes[1, 2].CheckedChanged += new EventHandler(pixelCheckBoxes12_CheckedChanged);
            pixelCheckBoxes[2, 2].CheckedChanged += new EventHandler(pixelCheckBoxes22_CheckedChanged);
            pixelCheckBoxes[3, 2].CheckedChanged += new EventHandler(pixelCheckBoxes32_CheckedChanged);
            pixelCheckBoxes[4, 2].CheckedChanged += new EventHandler(pixelCheckBoxes42_CheckedChanged);
            pixelCheckBoxes[0, 3].CheckedChanged += new EventHandler(pixelCheckBoxes03_CheckedChanged);
            pixelCheckBoxes[1, 3].CheckedChanged += new EventHandler(pixelCheckBoxes13_CheckedChanged);
            pixelCheckBoxes[2, 3].CheckedChanged += new EventHandler(pixelCheckBoxes23_CheckedChanged);
            pixelCheckBoxes[3, 3].CheckedChanged += new EventHandler(pixelCheckBoxes33_CheckedChanged);
            pixelCheckBoxes[4, 3].CheckedChanged += new EventHandler(pixelCheckBoxes43_CheckedChanged);
            pixelCheckBoxes[0, 4].CheckedChanged += new EventHandler(pixelCheckBoxes04_CheckedChanged);
            pixelCheckBoxes[1, 4].CheckedChanged += new EventHandler(pixelCheckBoxes14_CheckedChanged);
            pixelCheckBoxes[2, 4].CheckedChanged += new EventHandler(pixelCheckBoxes24_CheckedChanged);
            pixelCheckBoxes[3, 4].CheckedChanged += new EventHandler(pixelCheckBoxes34_CheckedChanged);
            pixelCheckBoxes[4, 4].CheckedChanged += new EventHandler(pixelCheckBoxes44_CheckedChanged);
            pixelCheckBoxes[0, 5].CheckedChanged += new EventHandler(pixelCheckBoxes05_CheckedChanged);
            pixelCheckBoxes[1, 5].CheckedChanged += new EventHandler(pixelCheckBoxes15_CheckedChanged);
            pixelCheckBoxes[2, 5].CheckedChanged += new EventHandler(pixelCheckBoxes25_CheckedChanged);
            pixelCheckBoxes[3, 5].CheckedChanged += new EventHandler(pixelCheckBoxes35_CheckedChanged);
            pixelCheckBoxes[4, 5].CheckedChanged += new EventHandler(pixelCheckBoxes45_CheckedChanged);
            pixelCheckBoxes[0, 6].CheckedChanged += new EventHandler(pixelCheckBoxes06_CheckedChanged);
            pixelCheckBoxes[1, 6].CheckedChanged += new EventHandler(pixelCheckBoxes16_CheckedChanged);
            pixelCheckBoxes[2, 6].CheckedChanged += new EventHandler(pixelCheckBoxes26_CheckedChanged);
            pixelCheckBoxes[3, 6].CheckedChanged += new EventHandler(pixelCheckBoxes36_CheckedChanged);
            pixelCheckBoxes[4, 6].CheckedChanged += new EventHandler(pixelCheckBoxes46_CheckedChanged);
            pixelCheckBoxes[0, 7].CheckedChanged += new EventHandler(pixelCheckBoxes07_CheckedChanged);
            pixelCheckBoxes[1, 7].CheckedChanged += new EventHandler(pixelCheckBoxes17_CheckedChanged);
            pixelCheckBoxes[2, 7].CheckedChanged += new EventHandler(pixelCheckBoxes27_CheckedChanged);
            pixelCheckBoxes[3, 7].CheckedChanged += new EventHandler(pixelCheckBoxes37_CheckedChanged);
            pixelCheckBoxes[4, 7].CheckedChanged += new EventHandler(pixelCheckBoxes47_CheckedChanged);
            #endregion
            characterComboBox.SelectedIndex = 0;
            FillCheckboxes();
        }

        /////////////////////////////////////////////////MAIN FORM EVENTS////////////////////////////////////////////////
        private void MainFrm_FormClosed(object sender, FormClosedEventArgs e) { GC.Collect(); }

        /////////////////////////////////////////////////CONTROLS EVENTS/////////////////////////////////////////////////
        //Line Text Boxes.
        private void lineOneTextBox_TextChanged(object sender, EventArgs e)
        {
            lcdModule.WriteString(LCDModule.Rows.Row01, lineOneTextBox.Text.Length, "".PadRight(Math.Max(0, 40 - lineOneTextBox.Text.Length), ' '));
            lcdModule.WriteString(LCDModule.Rows.Row01, 0, lineOneTextBox.Text);
        }
        private void lineTwoTextBox_TextChanged(object sender, EventArgs e)
        {
            lcdModule.WriteString(LCDModule.Rows.Row02, lineTwoTextBox.Text.Length, "".PadRight(Math.Max(0, 40 - lineTwoTextBox.Text.Length), ' '));
            lcdModule.WriteString(LCDModule.Rows.Row02, 0, lineTwoTextBox.Text);
        }
        private void lineOneTextBox_MouseDown(object sender, MouseEventArgs e)
        {
            if ((lineOneTextBox.Text.Length == 0) && (lineTwoTextBox.Text.Length == 0))
            {
                lcdModule.Instruction(LCDModule.Instructions.ClearScreen);
                lcdModule.Instruction(LCDModule.Instructions.ReturnHome);
            }
        }
        private void lineTwoTextBox_MouseDown(object sender, MouseEventArgs e)
        {
            if ((lineOneTextBox.Text.Length == 0) && (lineTwoTextBox.Text.Length == 0))
            {
                lcdModule.Instruction(LCDModule.Instructions.ClearScreen);
                lcdModule.Instruction(LCDModule.Instructions.ReturnHome);
            }
        }
        //Font Controls.
        private void characterComboBox_SelectedIndexChanged(object sender, EventArgs e) { FillCheckboxes(); }

        #region Pixel Check Boxes Events
        private void pixelCheckBoxes00_CheckedChanged(object sender, EventArgs e) { charactersFont[characterComboBox.SelectedIndex].SetValue(0, 0, pixelCheckBoxes[0, 0].Checked); UpdateDesiredCharacterFont(); }
        private void pixelCheckBoxes10_CheckedChanged(object sender, EventArgs e) { charactersFont[characterComboBox.SelectedIndex].SetValue(1, 0, pixelCheckBoxes[1, 0].Checked); UpdateDesiredCharacterFont(); }
        private void pixelCheckBoxes20_CheckedChanged(object sender, EventArgs e) { charactersFont[characterComboBox.SelectedIndex].SetValue(2, 0, pixelCheckBoxes[2, 0].Checked); UpdateDesiredCharacterFont(); }
        private void pixelCheckBoxes30_CheckedChanged(object sender, EventArgs e) { charactersFont[characterComboBox.SelectedIndex].SetValue(3, 0, pixelCheckBoxes[3, 0].Checked); UpdateDesiredCharacterFont(); }
        private void pixelCheckBoxes40_CheckedChanged(object sender, EventArgs e) { charactersFont[characterComboBox.SelectedIndex].SetValue(4, 0, pixelCheckBoxes[4, 0].Checked); UpdateDesiredCharacterFont(); }
        private void pixelCheckBoxes01_CheckedChanged(object sender, EventArgs e) { charactersFont[characterComboBox.SelectedIndex].SetValue(0, 1, pixelCheckBoxes[0, 1].Checked); UpdateDesiredCharacterFont(); }
        private void pixelCheckBoxes11_CheckedChanged(object sender, EventArgs e) { charactersFont[characterComboBox.SelectedIndex].SetValue(1, 1, pixelCheckBoxes[1, 1].Checked); UpdateDesiredCharacterFont(); }
        private void pixelCheckBoxes21_CheckedChanged(object sender, EventArgs e) { charactersFont[characterComboBox.SelectedIndex].SetValue(2, 1, pixelCheckBoxes[2, 1].Checked); UpdateDesiredCharacterFont(); }
        private void pixelCheckBoxes31_CheckedChanged(object sender, EventArgs e) { charactersFont[characterComboBox.SelectedIndex].SetValue(3, 1, pixelCheckBoxes[3, 1].Checked); UpdateDesiredCharacterFont(); }
        private void pixelCheckBoxes41_CheckedChanged(object sender, EventArgs e) { charactersFont[characterComboBox.SelectedIndex].SetValue(4, 1, pixelCheckBoxes[4, 1].Checked); UpdateDesiredCharacterFont(); }
        private void pixelCheckBoxes02_CheckedChanged(object sender, EventArgs e) { charactersFont[characterComboBox.SelectedIndex].SetValue(0, 2, pixelCheckBoxes[0, 2].Checked); UpdateDesiredCharacterFont(); }
        private void pixelCheckBoxes12_CheckedChanged(object sender, EventArgs e) { charactersFont[characterComboBox.SelectedIndex].SetValue(1, 2, pixelCheckBoxes[1, 2].Checked); UpdateDesiredCharacterFont(); }
        private void pixelCheckBoxes22_CheckedChanged(object sender, EventArgs e) { charactersFont[characterComboBox.SelectedIndex].SetValue(2, 2, pixelCheckBoxes[2, 2].Checked); UpdateDesiredCharacterFont(); }
        private void pixelCheckBoxes32_CheckedChanged(object sender, EventArgs e) { charactersFont[characterComboBox.SelectedIndex].SetValue(3, 2, pixelCheckBoxes[3, 2].Checked); UpdateDesiredCharacterFont(); }
        private void pixelCheckBoxes42_CheckedChanged(object sender, EventArgs e) { charactersFont[characterComboBox.SelectedIndex].SetValue(4, 2, pixelCheckBoxes[4, 2].Checked); UpdateDesiredCharacterFont(); }
        private void pixelCheckBoxes03_CheckedChanged(object sender, EventArgs e) { charactersFont[characterComboBox.SelectedIndex].SetValue(0, 3, pixelCheckBoxes[0, 3].Checked); UpdateDesiredCharacterFont(); }
        private void pixelCheckBoxes13_CheckedChanged(object sender, EventArgs e) { charactersFont[characterComboBox.SelectedIndex].SetValue(1, 3, pixelCheckBoxes[1, 3].Checked); UpdateDesiredCharacterFont(); }
        private void pixelCheckBoxes23_CheckedChanged(object sender, EventArgs e) { charactersFont[characterComboBox.SelectedIndex].SetValue(2, 3, pixelCheckBoxes[2, 3].Checked); UpdateDesiredCharacterFont(); }
        private void pixelCheckBoxes33_CheckedChanged(object sender, EventArgs e) { charactersFont[characterComboBox.SelectedIndex].SetValue(3, 3, pixelCheckBoxes[3, 3].Checked); UpdateDesiredCharacterFont(); }
        private void pixelCheckBoxes43_CheckedChanged(object sender, EventArgs e) { charactersFont[characterComboBox.SelectedIndex].SetValue(4, 3, pixelCheckBoxes[4, 3].Checked); UpdateDesiredCharacterFont(); }
        private void pixelCheckBoxes04_CheckedChanged(object sender, EventArgs e) { charactersFont[characterComboBox.SelectedIndex].SetValue(0, 4, pixelCheckBoxes[0, 4].Checked); UpdateDesiredCharacterFont(); }
        private void pixelCheckBoxes14_CheckedChanged(object sender, EventArgs e) { charactersFont[characterComboBox.SelectedIndex].SetValue(1, 4, pixelCheckBoxes[1, 4].Checked); UpdateDesiredCharacterFont(); }
        private void pixelCheckBoxes24_CheckedChanged(object sender, EventArgs e) { charactersFont[characterComboBox.SelectedIndex].SetValue(2, 4, pixelCheckBoxes[2, 4].Checked); UpdateDesiredCharacterFont(); }
        private void pixelCheckBoxes34_CheckedChanged(object sender, EventArgs e) { charactersFont[characterComboBox.SelectedIndex].SetValue(3, 4, pixelCheckBoxes[3, 4].Checked); UpdateDesiredCharacterFont(); }
        private void pixelCheckBoxes44_CheckedChanged(object sender, EventArgs e) { charactersFont[characterComboBox.SelectedIndex].SetValue(4, 4, pixelCheckBoxes[4, 4].Checked); UpdateDesiredCharacterFont(); }
        private void pixelCheckBoxes05_CheckedChanged(object sender, EventArgs e) { charactersFont[characterComboBox.SelectedIndex].SetValue(0, 5, pixelCheckBoxes[0, 5].Checked); UpdateDesiredCharacterFont(); }
        private void pixelCheckBoxes15_CheckedChanged(object sender, EventArgs e) { charactersFont[characterComboBox.SelectedIndex].SetValue(1, 5, pixelCheckBoxes[1, 5].Checked); UpdateDesiredCharacterFont(); }
        private void pixelCheckBoxes25_CheckedChanged(object sender, EventArgs e) { charactersFont[characterComboBox.SelectedIndex].SetValue(2, 5, pixelCheckBoxes[2, 5].Checked); UpdateDesiredCharacterFont(); }
        private void pixelCheckBoxes35_CheckedChanged(object sender, EventArgs e) { charactersFont[characterComboBox.SelectedIndex].SetValue(3, 5, pixelCheckBoxes[3, 5].Checked); UpdateDesiredCharacterFont(); }
        private void pixelCheckBoxes45_CheckedChanged(object sender, EventArgs e) { charactersFont[characterComboBox.SelectedIndex].SetValue(4, 5, pixelCheckBoxes[4, 5].Checked); UpdateDesiredCharacterFont(); }
        private void pixelCheckBoxes06_CheckedChanged(object sender, EventArgs e) { charactersFont[characterComboBox.SelectedIndex].SetValue(0, 6, pixelCheckBoxes[0, 6].Checked); UpdateDesiredCharacterFont(); }
        private void pixelCheckBoxes16_CheckedChanged(object sender, EventArgs e) { charactersFont[characterComboBox.SelectedIndex].SetValue(1, 6, pixelCheckBoxes[1, 6].Checked); UpdateDesiredCharacterFont(); }
        private void pixelCheckBoxes26_CheckedChanged(object sender, EventArgs e) { charactersFont[characterComboBox.SelectedIndex].SetValue(2, 6, pixelCheckBoxes[2, 6].Checked); UpdateDesiredCharacterFont(); }
        private void pixelCheckBoxes36_CheckedChanged(object sender, EventArgs e) { charactersFont[characterComboBox.SelectedIndex].SetValue(3, 6, pixelCheckBoxes[3, 6].Checked); UpdateDesiredCharacterFont(); }
        private void pixelCheckBoxes46_CheckedChanged(object sender, EventArgs e) { charactersFont[characterComboBox.SelectedIndex].SetValue(4, 6, pixelCheckBoxes[4, 6].Checked); UpdateDesiredCharacterFont(); }
        private void pixelCheckBoxes07_CheckedChanged(object sender, EventArgs e) { charactersFont[characterComboBox.SelectedIndex].SetValue(0, 7, pixelCheckBoxes[0, 7].Checked); UpdateDesiredCharacterFont(); }
        private void pixelCheckBoxes17_CheckedChanged(object sender, EventArgs e) { charactersFont[characterComboBox.SelectedIndex].SetValue(1, 7, pixelCheckBoxes[1, 7].Checked); UpdateDesiredCharacterFont(); }
        private void pixelCheckBoxes27_CheckedChanged(object sender, EventArgs e) { charactersFont[characterComboBox.SelectedIndex].SetValue(2, 7, pixelCheckBoxes[2, 7].Checked); UpdateDesiredCharacterFont(); }
        private void pixelCheckBoxes37_CheckedChanged(object sender, EventArgs e) { charactersFont[characterComboBox.SelectedIndex].SetValue(3, 7, pixelCheckBoxes[3, 7].Checked); UpdateDesiredCharacterFont(); }
        private void pixelCheckBoxes47_CheckedChanged(object sender, EventArgs e) { charactersFont[characterComboBox.SelectedIndex].SetValue(4, 7, pixelCheckBoxes[4, 7].Checked); UpdateDesiredCharacterFont(); }
        #endregion

        private void clearButton_Click(object sender, EventArgs e)
        {
            charactersFont[characterComboBox.SelectedIndex].Clear();
            FillCheckboxes();
            UpdateDesiredCharacterFont();
        }
        private void horizontalFlipButton_Click(object sender, EventArgs e)
        {
            charactersFont[characterComboBox.SelectedIndex].HorizontalFlip();
            FillCheckboxes();
            UpdateDesiredCharacterFont();
        }
        private void verticalFlipButton_Click(object sender, EventArgs e)
        {
            charactersFont[characterComboBox.SelectedIndex].VerticalFlip();
            FillCheckboxes();
            UpdateDesiredCharacterFont();
        }
        private void negativeButton_Click(object sender, EventArgs e)
        {
            charactersFont[characterComboBox.SelectedIndex].Negative();
            FillCheckboxes();
            UpdateDesiredCharacterFont();
        }
        private void previewButton_Click(object sender, EventArgs e)
        {
            lineOneTextBox.Text = "";
            lineTwoTextBox.Text = "";
            lcdModule.Instruction(LCDModule.Instructions.ClearScreen);
            lcdModule.Instruction(LCDModule.Instructions.ReturnHome);
            byte[] byteArray = { 0, 1, 2, 3, 4, 5, 6, 7 };
            lcdModule.WriteString(LCDModule.Rows.Row01, 0, byteArray);
            for (int i = 0; i < byteArray.Length; i++) byteArray[i] += 48;
            lcdModule.WriteString(LCDModule.Rows.Row02, 0, byteArray);
        }
        private void FillCheckboxes()
        {
            for (int i = 0; i < 5; i++)
                for (int j = 0; j < 8; j++)
                    pixelCheckBoxes[i, j].Checked = charactersFont[characterComboBox.SelectedIndex].GetValue(i, j);
        }
        private void UpdateDesiredCharacterFont()
        {
            lcdModule.SetFont((LCDModule.FontCharacterCodes)characterComboBox.SelectedIndex, charactersFont[characterComboBox.SelectedIndex]);
        }
        //Instruction Buttons.
        private void clearScreenButton_Click(object sender, EventArgs e) { lcdModule.Instruction(LCDModule.Instructions.ClearScreen); lineOneTextBox.Text = ""; lineTwoTextBox.Text = ""; }
        private void returnHomeButton_Click(object sender, EventArgs e) { lcdModule.Instruction(LCDModule.Instructions.ReturnHome); }
        private void displayOnButton_Click(object sender, EventArgs e) { lcdModule.Instruction(LCDModule.Instructions.DisplayOn); }
        private void displayOffButton_Click(object sender, EventArgs e) { lcdModule.Instruction(LCDModule.Instructions.DisplayOff); }
        private void cursorOnButton_Click(object sender, EventArgs e) { lcdModule.Instruction(LCDModule.Instructions.CursorOn); }
        private void cursorOffButton_Click(object sender, EventArgs e) { lcdModule.Instruction(LCDModule.Instructions.CursorOff); }
        private void blinkingOnButton_Click(object sender, EventArgs e) { lcdModule.Instruction(LCDModule.Instructions.BlinkingOn); }
        private void blinkingOffButton_Click(object sender, EventArgs e) { lcdModule.Instruction(LCDModule.Instructions.BlinkingOff); }

        /////////////////////////////////////////////////FILE SUBMENU/////////////////////////////////////////////////
        private void exitToolStripMenuItem_Click(object sender, EventArgs e) { Application.Exit(); }

        /////////////////////////////////////////////////HELP SUBMENU/////////////////////////////////////////////////
        private void helpTopicsToolStripMenuItem_Click(object sender, EventArgs e)
        {
            System.Diagnostics.Process.Start(Application.StartupPath + @"\..\..\..\SoftCollectionLCDModuleLibraryForNET.chm");
        }
        private void visitWebSiteToolStripMenuItem_Click(object sender, EventArgs e)
        {
            System.Diagnostics.Process.Start("http://www.soft-collection.com");
        }
        private void aboutToolStripMenuItem_Click(object sender, EventArgs e)
        {
            AboutBox about = new AboutBox();
            about.ShowDialog();
        }
    }
}